#include <stdlib.h>
#include <stdio.h>
#include <mlvalues.h>
#include <fail.h>
#include <sys/types.h>
#include <sys/stat.h>
#ifdef HAS_DIRENT
#include <dirent.h>
typedef struct dirent directory_entry;
#else
#include <sys/dir.h>
typedef struct direct directory_entry;
#endif
 


value gr_read_dir()             /* ML */
{
  DIR *dirp;
  directory_entry *direntp;
  struct stat buf;
  char temp[1024],c,*ptr;
  int len=0;

  value s;

  dirp=opendir(".");
  if( dirp != NULL)
    for(;;)
    {
      direntp = readdir (dirp);
      if(direntp==NULL) break;
    
      stat(direntp->d_name,&buf);
      if(S_ISDIR(buf.st_mode)) c='d'; else c='f';
      sprintf(temp,"%c %s\n",c, direntp->d_name);
      len+=strlen(temp);
    }
    closedir(dirp);

  s=alloc_string(len);
  ptr=String_val(s);
 
  dirp=opendir(".");
  if( dirp != NULL)
    for(;;)
    {
      direntp = readdir (dirp);
      if(direntp==NULL) break;
      stat(direntp->d_name,&buf);
      if(S_ISDIR(buf.st_mode)) c='d'; else c='f';
      sprintf(temp,"%c %s\n",c, direntp->d_name);
      strcpy(ptr,temp);
      ptr+=strlen(temp);
    }
    closedir(dirp);

    return s;
}


value gr_current_dir()          /* ML */
{
  char *cwd, *getcwd();
          
  cwd=getcwd((char *)NULL, 1024);
  if(cwd != NULL)
  {
    return copy_string(cwd);
  }
  gr_fail("%s","Can't get the current directory");

  return Val_unit;
}


